package com.bitendo.game;

import java.awt.Rectangle;
import java.awt.image.BufferedImage;
import java.util.Random;

public class Boss extends Entity{
	public int bosstype;
	boolean right=false;
	int a;
	int b;
	boolean d;
	int c;
	Random r=new Random();
	public Boss(BufferedImage sprite,int bosstype) {
		super(sprite);
		type=909;
		this.sprite=sprite;
		health=100;
		collisionMask=new Rectangle(x,y,96,96);
		this.bosstype=bosstype;
	}
	public void update(){
		collisionMask=new Rectangle(x+1,y+1,94,94);
		
		
		switch(bosstype){
		case 1:
			if(health>0){
				for(int i=0;i<Game.tiles.size();i++){
					if(collisionMask.intersects(Game.tiles.get(i).collisionMask)&&Game.tiles.get(i).type==2){
						health-=5;
						b=1;
					}
				}
				if(b>0 && b<25){
					sprite=Game.BOSSES.getSubimage(96,0,96,96);
					b++;
				}
				else if(b>=25){
					sprite=Game.BOSSES.getSubimage(0,0,96,96);
					b=0;
				}
				if(a<400){
					a++;
				}
				else{
					BossBullet b=new BossBullet(Game.BOSSES.getSubimage(192,0,32,32),7);
					b.x=x;
					b.y=y;
					Game.tiles.add(b);
					a=0;
				}
				if(right){
					
					x+=2;
					for(int i=0;i<Game.tiles.size();i++){
						if(collisionMask.intersects(Game.tiles.get(i).collisionMask)&&Game.tiles.get(i).type==1){
							right=false;
							x-=2;
						}
					}
				}
				else if(!right){
					
					x-=2;
					for(int i=0;i<Game.tiles.size();i++){
						if(collisionMask.intersects(Game.tiles.get(i).collisionMask)&&Game.tiles.get(i).type==1){
							right=true;
							x+=2;
						}
					}
				}
			}
			if(health<=0&&d==false){
				sprite=Game.BOSSES.getSubimage(96,0,96,96);
				
				Particle e=new Particle(Game.sprites.getSubimage(32,0,16,16));
				e.x=x;
				e.y=y;
				Game.tiles.add(e);
				Particle e2=new Particle(Game.sprites.getSubimage(32,0,16,16));
				e2.x=x;
				e2.y=y;
				Game.tiles.add(e2);
				Particle e3=new Particle(Game.sprites.getSubimage(32,0,16,16));
				e3.x=x;
				e3.y=y;
				Game.tiles.add(e3);
				Particle e4=new Particle(Game.sprites.getSubimage(32,0,16,16));
				e4.x=x;
				e4.y=y;
				Game.tiles.add(e4);
				d=true;
				
			}
			if(d&&c<250){
				
				c++;
			}
			if(d){
				for(int r=0;r<8;r++){
					Particle e=new Particle(Game.sprites.getSubimage(32,0,16,16));
					e.x=x;
					e.y=y;
					Game.tiles.add(e);
					Particle e2=new Particle(Game.sprites.getSubimage(32,0,16,16));
					e2.x=x;
					e2.y=y;
					Game.tiles.add(e2);
					Particle e3=new Particle(Game.sprites.getSubimage(32,0,16,16));
					e3.x=x;
					e3.y=y;
					Game.tiles.add(e3);
					Particle e4=new Particle(Game.sprites.getSubimage(32,0,16,16));
					e4.x=x;
					e4.y=y;
					Game.tiles.add(e4);
				}
				for(int i=0;i<Game.tiles.size();i++){
					if(Game.tiles.get(i).type==3){
						Game.tiles.get(i).removed=true;
					}
					if(Game.tiles.get(i).type==0){
						Game.tiles.get(i).health=100;
					}
				}
			}
			if(c==250){
				
				Game.boss=false;
				Game.wave++;
				
				
				Game.maxenemies+=25;
				Game.enemies=0;
				Game.killed=0;
				Game.levelLoaded=false;
				d=false;
				c=0;
				removed=true;
			}
			break;
		}
	}

}
