package com.bitendo.game;

import java.awt.Rectangle;
import java.awt.image.BufferedImage;

public class Enemy extends Entity{
	float inc=0.4f;
	public Enemy(BufferedImage sprite) {
		super(sprite);
		this.sprite=sprite;
		collisionMask=new Rectangle(x,y,16,16);
		type=3;
	}
	public void update(){
		collisionMask=new Rectangle(x-1,y-1,18,18);
		if(inc>0.8f){
			inc=0.1f;
		}
		for(int i=0;i<Game.tiles.size();i++){
			if(Game.tiles.get(i).type==0){
				if(Game.tiles.get(i).x>x&&Game.tiles.get(i)!=null){
					
					x+=Math.round(inc);
					
					
					inc+=0.1f;
					if(collisionMask.intersects(Game.tiles.get(i).collisionMask)&&Game.tiles.get(i).type==1){
						x--;
						inc=0;
					}
				}
				if(Game.tiles.get(i).x<x&&Game.tiles.get(i)!=null){
					x-=Math.round(inc);
					
					inc+=0.1f;
					if(collisionMask.intersects(Game.tiles.get(i).collisionMask)&&Game.tiles.get(i).type==1){
						x++;
						inc=0;
					}
				}
				if(Game.tiles.get(i).y>y&&Game.tiles.get(i)!=null){
					y+=Math.round(inc);
					
					inc+=0.1f;
					if(collisionMask.intersects(Game.tiles.get(i).collisionMask)&&Game.tiles.get(i).type==1){
						y--;
						inc=0;
					}
				}
				if(Game.tiles.get(i).y<y&&Game.tiles.get(i)!=null){
					y-=Math.round(inc);
					
					inc+=0.1f;
					if(collisionMask.intersects(Game.tiles.get(i).collisionMask)&&Game.tiles.get(i).type==1){
						y++;
						inc=0;
					}
				}
			}
			
			if(collisionMask.intersects(Game.tiles.get(i).collisionMask)&&Game.tiles.get(i).type==2){
				Particle e=new Particle(Game.sprites.getSubimage(32,0,16,16));
				e.x=x;
				e.y=y;
				Game.tiles.add(e);
				Particle e2=new Particle(Game.sprites.getSubimage(32,0,16,16));
				e2.x=x;
				e2.y=y;
				Game.tiles.add(e2);
				Particle e3=new Particle(Game.sprites.getSubimage(32,0,16,16));
				e3.x=x;
				e3.y=y;
				Game.tiles.add(e3);
				Particle e4=new Particle(Game.sprites.getSubimage(32,0,16,16));
				e4.x=x;
				e4.y=y;
				Game.tiles.add(e4);
				removed=true;
				Game.enemies--;
				Game.killed++;
				Game.explode.play();
			}
			xprev=x;
			yprev=y;
		}
		
	}

}
