package com.bitendo.game;

import java.awt.Rectangle;
import java.awt.image.BufferedImage;
import java.util.Random;

public class Player extends Entity{
	boolean prevw;
	boolean preva;
	boolean prevs;
	boolean prevd;
	int firetime;
	int sx,sy;
	int flash;
	boolean a;
	public Player(BufferedImage sprite){
		super(sprite);
		type=0;
		this.sprite=sprite;
		health=100;
		collisionMask=new Rectangle(x,y,16,16);
		
	}
	public void update(){
		collisionMask=new Rectangle(x,y,16,16);
		if(!a){
			sx=x;
			sy=y;
			a=true;
		}
		if(Game.h.left){
			
			x-=2;
			for(int i=0;i<Game.tiles.size();i++){
				if(new Rectangle(x-2,y,2,16).intersects(Game.tiles.get(i).collisionMask)&&Game.tiles.get(i).type!=2&&Game.tiles.get(i).type!=-24&&Game.tiles.get(i).type!=3&&Game.tiles.get(i).type!=909){
					x+=2;
				}
			}
		}
		if(firetime>0&&firetime<25){
			firetime++;
		}
		else{
			firetime=0;
		}
		if(Game.h.right){
			
			x+=2;
			for(int i=0;i<Game.tiles.size();i++){
				if(new Rectangle(x+18,y,2,16).intersects(Game.tiles.get(i).collisionMask)&&Game.tiles.get(i).type==1){
					x-=2;
				}
			}
		}
		if(Game.h.up){
			y-=2;
			for(int i=0;i<Game.tiles.size();i++){
				if(new Rectangle(x,y-2,16,2).intersects(Game.tiles.get(i).collisionMask)&&Game.tiles.get(i).type==1){
					y+=2;
				}
			}
		}
		if(Game.h.down){
			y+=2;
			for(int i=0;i<Game.tiles.size();i++){
				if(new Rectangle(x,y+18,16,2).intersects(Game.tiles.get(i).collisionMask)&&Game.tiles.get(i).type==1){
					y-=2;
				}
			}
		}
		if(Game.h.w&&prevw==false&&firetime==0){
			Bullet b=new Bullet(Game.sprites.getSubimage(16,16,16,16),1);
			b.x=x;
			b.y=y;
			Game.tiles.add(b);
			firetime=1;
			Game.gun.play();
		}
		if(Game.h.a&&preva==false&&firetime==0){
			Bullet b=new Bullet(Game.sprites.getSubimage(16,16,16,16),3);
			b.x=x;
			b.y=y;
			Game.tiles.add(b);
			firetime=1;
			Game.gun.play();
		}
		if(Game.h.s&&prevs==false&&firetime==0){
			Bullet b=new Bullet(Game.sprites.getSubimage(16,16,16,16),2);
			b.x=x;
			b.y=y;
			Game.tiles.add(b);
			firetime=1;
			Game.gun.play();
		}
		if(Game.h.d&&prevd==false&&firetime==0){
			Bullet b=new Bullet(Game.sprites.getSubimage(16,16,16,16),0);
			b.x=x;
			b.y=y;
			Game.tiles.add(b);
			firetime=1;
			Game.gun.play();
		}
		for(int i=0;i<Game.tiles.size();i++){
			if(Game.tiles.get(i).type==3&&Game.tiles.get(i).collisionMask.intersects(collisionMask)&&flash<=0){
				health-=15;
				flash=1;
			}
			if(Game.tiles.get(i).type==910&&Game.tiles.get(i).collisionMask.intersects(collisionMask)&&flash<=0){
				health-=50;
				flash=1;
			}
		}
		if(flash>0&&flash<100){
			flash++;
		}
		else{flash=0;}
		if(health<=0){
			die();
		}
		prevw=Game.h.w;
		preva=Game.h.a;
		prevs=Game.h.s;
		prevd=Game.h.d;
	}
	public void die(){
		health=100;
		x=sx;
		y=sy;
		Game.wave=0;
		Game.bc=0;
		Game.enemies=0;
		Game.tiles.clear();
		Game.loadLevel("res/test.txt");
	}
}
