package com.bitendo.game;

import java.awt.Rectangle;
import java.awt.image.BufferedImage;

public class Spawner extends Entity{
	int charge;
	public Spawner(BufferedImage sprite){
		super(sprite);
		this.sprite=sprite;
		collisionMask=new Rectangle(x,y,16,16);
		type=-5;
	}
	public void update(){
		collisionMask=new Rectangle(x,y,16,16);
		if(!Game.boss){
			if(charge<75){
				charge++;
			}
			else{
				for(int i=0;i<Game.tiles.size();i++){
					if(new Rectangle(x-16,y,16,16).intersects(Game.tiles.get(i).collisionMask)&&Game.enemies<=200){
						Enemy e=new Enemy(Game.sprites.getSubimage(16,0,16,16));
						e.x=x-16;
						e.y=y;
						Game.tiles.add(e);
						charge=0;
						Game.enemies++;
						return;
					}
					if(new Rectangle(x+16,y,16,16).intersects(Game.tiles.get(i).collisionMask)&&Game.enemies<=200){
						Enemy e=new Enemy(Game.sprites.getSubimage(16,0,16,16));
						e.x=x+16;
						e.y=y;
						Game.tiles.add(e);
						charge=0;
						Game.enemies++;
						return;
					}
					if(new Rectangle(x,y-16,16,16).intersects(Game.tiles.get(i).collisionMask)&&Game.enemies<=200){
						Enemy e=new Enemy(Game.sprites.getSubimage(16,0,16,16));
						e.x=x;
						e.y=y-16;
						Game.tiles.add(e);
						charge=0;
						Game.enemies++;
						return;
					}
					if(new Rectangle(x,y+16,16,16).intersects(Game.tiles.get(i).collisionMask)&&Game.enemies<=200){
						Enemy e=new Enemy(Game.sprites.getSubimage(16,0,16,16));
						e.x=x;
						e.y=y+16;
						Game.tiles.add(e);
						charge=0;
						Game.enemies++;
						return;
					}
				}
				
			}
		}
	}
}
