package com.bitendo.game;

import java.awt.Rectangle;
import java.awt.image.BufferedImage;

public class BossBullet extends Bullet{
	int a;
	public BossBullet(BufferedImage sprite, int direction) {
		super(sprite, direction);
		this.sprite=sprite;
		collisionMask=new Rectangle(x,y,32,32);
		this.direction=direction;
		type=910;
	}
	public void update(){
		collisionMask=new Rectangle(x-1,y-1,34,34);
		if(a<150){
			a++;
		}
		else{
			Particle e=new Particle(Game.sprites.getSubimage(32,0,16,16));
			e.x=x;
			e.y=y;
			Game.tiles.add(e);
			Particle e2=new Particle(Game.sprites.getSubimage(32,0,16,16));
			e2.x=x;
			e2.y=y;
			Game.tiles.add(e2);
			Particle e3=new Particle(Game.sprites.getSubimage(32,0,16,16));
			e3.x=x;
			e3.y=y;
			Game.tiles.add(e3);
			Particle e4=new Particle(Game.sprites.getSubimage(32,0,16,16));
			e4.x=x;
			e4.y=y;
			Game.tiles.add(e4);
			removed=true;
		}
		for(int i=0;i<Game.tiles.size();i++){
			if(Game.tiles.get(i).type==0){
				if(Game.tiles.get(i).x<x){
					x-=2;
				}
				if(Game.tiles.get(i).x>x+32){
					x+=2;
				}
				if(Game.tiles.get(i).y<y){
					y-=2;
				}
				if(Game.tiles.get(i).y>y+32){
					y+=2;
				}
			}
			if(collisionMask.intersects(Game.tiles.get(i).collisionMask)&&Game.tiles.get(i).type==0){
				Particle e=new Particle(Game.sprites.getSubimage(32,0,16,16));
				e.x=x;
				e.y=y;
				Game.tiles.add(e);
				Particle e2=new Particle(Game.sprites.getSubimage(32,0,16,16));
				e2.x=x;
				e2.y=y;
				Game.tiles.add(e2);
				Particle e3=new Particle(Game.sprites.getSubimage(32,0,16,16));
				e3.x=x;
				e3.y=y;
				Game.tiles.add(e3);
				Particle e4=new Particle(Game.sprites.getSubimage(32,0,16,16));
				e4.x=x;
				e4.y=y;
				Game.tiles.add(e4);
				removed=true;
			}
		}
	}
}
