package com.bitendo.game;

import java.awt.Rectangle;
import java.awt.image.BufferedImage;

public class Bullet extends Entity{
	int direction;
	
	public Bullet(BufferedImage sprite,int direction) {
		super(sprite);
		this.sprite=sprite;
		collisionMask=new Rectangle(x,y,16,16);
		this.direction=direction;
		type=2;
	}
	public void update(){
		collisionMask=new Rectangle(x,y,16,16);
		if(direction==0){
			x+=8;
		}
		if(direction==1){
			y-=8;
		}
		if(direction==2){
			x-=8;
		}
		if(direction==3){
			y+=8;
		}
		for(int i=0;i<Game.tiles.size();i++){
			if(collisionMask.intersects(Game.tiles.get(i).collisionMask)&&Game.tiles.get(i).type!=0&&Game.tiles.get(i).type!=2&&Game.tiles.get(i).type!=-24&&!removed){
				removed=true;
				return;
			}
			else{
				removed=false;
			}
			
		}
	}
	
}
